/**************************************************************************
 *
 * Filename:    Hprobe.c
 *
 * Copyright:   Pico Technology Limited 2005
 *
 *              www.picotech.com
 *
 * Author:      MAS
 *
 * Description:
 *   This file demonstrates how to use the HumidiProbe driver from within
 *   a Windows application.
 *
 * History:
 * Created 15 March 05 MAS
 * Revision Info: "file %n date %f revision %v"
 *                ""
 *
 ***************************************************************************/

#include <windows.h>
#include <stdio.h>
#define WINDOWS
#include "HumidiProbeApi.h"
#include "resource.h"

static short handle;

#define ID_TIMER 1

/****************************************************************************
 *
 *
 ****************************************************************************/

long CALLBACK WndProc (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
  short  ok;
  char  line [80];
  float  temp;
	float  humidity;
	int i;
	char str[80];

  switch (message)
  {
    case WM_TIMER:
     
	  ok  = HumidiProbeGetSingleValue(handle, &temp, &humidity);
	  if (ok)
	  {
	    sprintf (line, "%6.2f", temp);
	    SetDlgItemText (hwnd, 100, line);
			sprintf (line, "%6.2f", humidity);
	    SetDlgItemText (hwnd, 101, line);
	  }
  	else
	  {
	    SetDlgItemText (hwnd, 100, "****");
			SetDlgItemText (hwnd, 101, "****");
	  }
	
    return 0;

	case WM_DESTROY:
	  if (handle)
    {
			HumidiProbeCloseUnit(handle);
    }
    KillTimer (hwnd, ID_TIMER);
	  PostQuitMessage (0) ;
    return 0 ;
	}

  return (long) DefWindowProc (hwnd, message, wParam, lParam) ;
}

/****************************************************************************
 *
 *
 ****************************************************************************/
int __stdcall WinMain (HINSTANCE hInst,
											 HINSTANCE hPrevInstance,
                       LPSTR lpszCmdLine,
                       int nCmdShow)
{
  static char 		szAppName [] = "HPROBE" ;
  HWND        		hwnd ;
  MSG         		msg;
  WNDCLASS    		wndclass ;


	if (!(handle = HumidiProbeOpenUnit()))
    {
    MessageBox (NULL, "Unable to open unit", "Error", MB_ICONEXCLAMATION);
    exit (99);
    }

  if (!hPrevInstance)
    {
    wndclass.style          = CS_HREDRAW | CS_VREDRAW;
    wndclass.lpfnWndProc    = (WNDPROC)WndProc;
    wndclass.cbClsExtra     = 0 ;
    wndclass.cbWndExtra     = DLGWINDOWEXTRA ;
    wndclass.hInstance      = hInst;
    wndclass.hIcon          = NULL;
    wndclass.hCursor        = LoadCursor (NULL, IDC_ARROW);
    wndclass.hbrBackground  = (HBRUSH)(COLOR_WINDOW + 1);
    wndclass.lpszMenuName   = NULL ;
    wndclass.lpszClassName  = szAppName ;

    RegisterClass (&wndclass) ;
    }

  hwnd = CreateDialog (hInst, szAppName, 0, NULL) ;

  SetTimer (hwnd, ID_TIMER, 1000, NULL);

  ShowWindow (hwnd, nCmdShow) ;

  while (GetMessage (&msg, NULL, 0, 0))
                {
                DispatchMessage (&msg) ;
                }

  return (int) msg.wParam ;
}

